#ifndef WYKRES_HEAD
#define WYKRES_HEAD

#include "./mat.h"
#include <QApplication>
#include <QPushButton>
#include <QWidget>
#include <QGridLayout>
#include <QPainter>
#include <QLCDNumber>
#include <QSlider>
#include <QLabel>
#include <QColor>
#include <QString>

class wykres:public QWidget
{

Q_OBJECT

  private:

  double hsize;
  double vsize;
  double hskip;

  public:

  wykres(QWidget *parent=0);

  QLCDNumber *xvalue;
  QLCDNumber *yvalue;
  QLCDNumber *scalelcd;
  QLCDNumber *axlcd;
  QLCDNumber *aylcd;
  QLCDNumber *bxlcd;
  QLCDNumber *bylcd;
  QLCDNumber *cxlcd;
  QLCDNumber *cylcd;
  QLCDNumber *dxlcd;
  QLCDNumber *dylcd;
  QSlider *xchange;
  QSlider *ychange;
  QSlider *scaleslider;
  QSlider *axslider;
  QSlider *ayslider;
  QSlider *bxslider;
  QSlider *byslider;
  QSlider *cxslider;
  QSlider *cyslider;
  QSlider *dxslider;
  QSlider *dyslider;
  QWidget *sourcechange;
  QWidget *scalechange;
  QWidget *parameterchange;
  QVBoxLayout *schangelayout;
  QVBoxLayout *scalechangelay;
  QGridLayout *paramchangelayout;
  QLabel *sourcelabel;
  QLabel *scalechangelabel;
  QLabel *parameterlabel;
  QLabel *parameterlabela;
  QLabel *parameterlabelb;
  QLabel *parameterlabelc;
  QLabel *parameterlabeld;
  QString opis_tekstu;

  zespolone a,b,c,d;
  zespolone centresource;  // srodek ukladu odniesienia po lewej
  zespolone centretarget;  // srodek ukladu odniesienia po prawej
  zespolone rangesource;
  zespolone rangetarget;
  long double scaleellipse;

  // te wielkosci sa zmieniane.
  zespolone a2,b2,c2,d2; // parametry homografii
  zespolone centresource2;  // srodek ukladu odniesienia po lewej
  zespolone centretarget2;  // srodek ukladu odniesienia po prawej
  zespolone rangesource2;
  zespolone rangetarget2;
  long double deltax,deltay,deltael;
  long double scaleellipse2;
  long double dax,day,dbx,dby,dcx,dcy,ddx,ddy;

  int typrysowania; // 0 --- osie pionowe, 1 --- osie poziome, 2 --- kola scentrowane, 3 -- elipsy scentrowane

  int ilosclinii;
  int typfunkcji;

 protected:

  void paintEvent(QPaintEvent *event);

  signals:

  void changetargetx(double);
  void changetargety(double);
  void changescaleell(double);
  void changeax(double);
  void changeay(double);
  void changebx(double);
  void changeby(double);
  void changecx(double);
  void changecy(double);
  void changedx(double);
  void changedy(double);
  void textchanged(QString);

  public slots:

  void doublerangesource();
  void doublerangetarget();
  void halfrangesource();
  void halfrangetarget();
  void liniepoziome();
  void liniepionowe();
  void okregi();
  void elipsy();
  void promienie();
  void linie();
  void okregiilinie();
  void Shomografia();
  void Sexp();
  void Szukowski();
  void Skwadrat();
  void Sszescian();
  void Sdigamma();
  void Sarcsine();
  void Slogarithm();
  void Ssquareroot();
  void Snakwadrat();
  void Stangens();
  void Sarctangens();
  void Sarctangensh();
  void Sbezcwiartki();
  void SschwarzchristII();
  void Slogcoth();
  void SschwarzchristIII();
  void SschwarzchristIV();

  void zwiekszilosclinii();
  void zmniejszilosclinii();
  void changecentretarget();
  void changecentretargetrefreshx(int);
  void changecentretargetrefreshy(int);
  void schangedestroyed();
  void moveinfinitytoorigin();
  void changeellipsescale();
  void ellipsescalechanged(int);
  void ellipsechangedestroyed();
  void parameterchangestart();
  void parameterchangedestroyed();
  void parameterchangedax(int);
  void parameterchangeday(int);
  void parameterchangedbx(int);
  void parameterchangedby(int);
  void parameterchangedcx(int);
  void parameterchangedcy(int);
  void parameterchangeddx(int);
  void parameterchangeddy(int);
};

#endif




